/**
 * Created by robin on 10/24/15.
 */

(function () {
    'use strict';
    angular.module('luticate2Utils')
        .factory('luRequest', ['$q', '$http', 'luBusyBusiness', function ($q, $http, luBusyBusiness) {

            var luRequest = {};

            luRequest.get = function(url, dataGet, luBusyDbo)
            {
                return luRequest.request(url, 'GET', dataGet, null, luBusyDbo);
            };

            luRequest.post = function(url, dataGet, dataPost, luBusyDbo)
            {
                return luRequest.request(url, 'POST', dataGet, dataPost, luBusyDbo);
            };

            luRequest.put = function(url, dataGet, dataPost, luBusyDbo)
            {
                return luRequest.request(url, 'PUT', dataGet, dataPost, luBusyDbo);
            };

            luRequest.delete = function(url, dataGet, dataPost, luBusyDbo)
            {
                return luRequest.request(url, 'DELETE', dataGet, dataPost, luBusyDbo);
            };

            function reject(deferred, data, status, luBusyDbo)
            {
                var obj = {
                    data: data,
                    status: status
                };
                deferred.reject(obj);
                if (luBusyDbo != null) {
                    luBusyBusiness.reject(luBusyDbo, obj);
                }
            }

            function resolve(deferred, data, luBusyDbo)
            {
                deferred.resolve(data);
                if (luBusyDbo != null) {
                    luBusyBusiness.resolve(luBusyDbo);
                }
            }

            luRequest.request = function(url, method, dataGet, dataPost, luBusyDbo)
            {
                if (luBusyDbo != null) {
                    luBusyBusiness.initLuBusy(luBusyDbo);
                }
                var deferred = $q.defer();

                url = url.replace(/\/+$/, '');

                var params = {
                    url: url,
                    method: method,
                    params: dataGet,
                    data: dataPost,
                    headers: {
                        'Content-Type': "application/json"
                    }
                };

                $http(params)
                    .then(function (response) {
                        var result = response.data;
                        var status = response.status;
                        if (result == null) {
                            reject(deferred, "Failed to parse response", status, luBusyDbo);
                        }
                        else if (result.message != null) {
                            reject(deferred, result.message, status, luBusyDbo);
                        }
                        else {
                            resolve(deferred, result.data, luBusyDbo);
                        }
                    }, function (response) {
                        var result = response.data;
                        var status = response.status;
                        if (result == null) {
                            reject(deferred, "Failed to parse response", status, luBusyDbo);
                        }
                        else if (result.message != null) {
                            reject(deferred, result.message, status, luBusyDbo);
                        }
                        else {
                            reject(deferred, result, status, luBusyDbo);
                        }
                    });
                return deferred.promise;
            };

            return luRequest;
        }]);
})();
